include:
  - project: 'resto-rate/ci-templates'
    ref: 'master'
    file:
      - 'templates.gitlab-ci.yml'

stages:
  - Build
  - Prepare
  - Deploy
  - Undeploy

"Docker build":
  stage: Build
  extends:
  - ".docker"
  rules:
  - changes:
    - cmd/**/*
    - internal/**/*
    - conf.yaml
    - Dockerfile
    - go.mod
    - go.sum

"Docker retag":
  stage: Build
  extends:
  - ".retag"
  rules:
  - changes:
    - cmd/**/*
    - internal/**/*
    - conf.yaml
    - Dockerfile
    - go.mod
    - go.sum
    when: never
  - when: on_success

"Helm package":
  stage: Build
  extends:
  - ".helm"
  rules:
  - changes:
    - helm/**/*

"Prepare namespace":
  stage: Prepare
  extends:
  - ".prepare-namespace"

"Deploy":
  stage: Deploy
  extends:
  - ".deploy"
  before_script:
  - export EXTRA_SET="$(if [ $CI_COMMIT_BRANCH = 'master' ] || [ $CI_COMMIT_BRANCH = 'develop' ]; then echo '--set ingress.enabled=false'; fi;) --set s3.accessKey=$S3_ACCESS_KEY --set s3.secretKey=$S3_SECRET_KEY"
  environment:
    name: $ENV_TIER/$CI_COMMIT_REF_NAME
    url: https://$CI_PROJECT_NAME-$NAMESPACE.restorate.space
    on_stop: "Stop review"

"Stop review":
  stage: Deploy
  extends:
  - ".delete-namespace"
  - ".manual"
  environment:
    name: $ENV_TIER/$CI_COMMIT_REF_NAME
    action: stop
  variables:
    GIT_STRATEGY: none

"Undeploy":
  stage: Undeploy
  extends:
  - ".undeploy"
  - ".manual"

"Delete namespace":
  stage: Undeploy
  extends:
  - ".delete-namespace"
  - ".manual"
